diff --git a/web/pgadmin/misc/dependencies/static/js/Dependencies.jsx b/web/pgadmin/misc/dependencies/static/js/Dependencies.jsx
index ee7ea6e46..ccb605d67 100644
--- a/web/pgadmin/misc/dependencies/static/js/Dependencies.jsx
+++ b/web/pgadmin/misc/dependencies/static/js/Dependencies.jsx
@@ -16,6 +16,7 @@ import Notify from '../../../../static/js/helpers/Notifier';
 import getApiInstance from 'sources/api_instance';
 import { makeStyles } from '@material-ui/core/styles';
 import { getURL } from '../../../static/utils/utils';
+import Loader from 'sources/components/Loader';
 
 const useStyles = makeStyles((theme) => ({
   emptyPanel: {
@@ -71,7 +72,7 @@ function parseData(data, node) {
 export default function Dependencies({ nodeData, item, node, ...props }) {
   const classes = useStyles();
   const [tableData, setTableData] = React.useState([]);
-
+  const [loaderText, setLoaderText] = React.useState('');
   const [msg, setMsg] = React.useState('');
   var columns = [
     {
@@ -79,14 +80,14 @@ export default function Dependencies({ nodeData, item, node, ...props }) {
       accessor: 'type',
       sortble: true,
       resizable: false,
-      disableGlobalFilter: true,
+      disableGlobalFilter: false,
     },
     {
       Header: 'Name',
       accessor: 'name',
       sortble: true,
       resizable: false,
-      disableGlobalFilter: true,
+      disableGlobalFilter: false,
     },
     {
       Header: 'Restriction',
@@ -114,7 +115,7 @@ export default function Dependencies({ nodeData, item, node, ...props }) {
       );
       if (node.hasDepends) {
         const api = getApiInstance();
-
+        setLoaderText('Loading...');
         api({
           url: url,
           type: 'GET',
@@ -123,8 +124,10 @@ export default function Dependencies({ nodeData, item, node, ...props }) {
             if (res.data.length > 0) {
               let data = parseData(res.data, node);
               setTableData(data);
+              setLoaderText('');
             } else {
               setMsg(message);
+              setLoaderText('');
             }
           })
           .catch((e) => {
@@ -157,10 +160,12 @@ export default function Dependencies({ nodeData, item, node, ...props }) {
         ></PgTable>
       ) : (
         <div className={classes.emptyPanel}>
-          <div className={classes.panelIcon}>
-            <i className="fa fa-exclamation-circle"></i>
-            <span className={classes.panelMessage}>{gettext(msg)}</span>
-          </div>
+          {loaderText ? (<Loader message={loaderText} className={classes.loading} />) :
+            <div className={classes.panelIcon}>
+              <i className="fa fa-exclamation-circle"></i>
+              <span className={classes.panelMessage}>{gettext(msg)}</span>
+            </div>
+          }
         </div>
       )}
     </>
diff --git a/web/pgadmin/misc/dependents/static/js/Dependents.jsx b/web/pgadmin/misc/dependents/static/js/Dependents.jsx
index 487e2d29b..867368b97 100644
--- a/web/pgadmin/misc/dependents/static/js/Dependents.jsx
+++ b/web/pgadmin/misc/dependents/static/js/Dependents.jsx
@@ -16,6 +16,7 @@ import Notify from '../../../../static/js/helpers/Notifier';
 import getApiInstance from 'sources/api_instance';
 import { makeStyles } from '@material-ui/core/styles';
 import { getURL } from '../../../static/utils/utils';
+import Loader from 'sources/components/Loader';
 
 const useStyles = makeStyles((theme) => ({
   emptyPanel: {
@@ -71,7 +72,7 @@ function parseData(data, node) {
 export default function Dependents({ nodeData, item, node, ...props }) {
   const classes = useStyles();
   const [tableData, setTableData] = React.useState([]);
-
+  const [loaderText, setLoaderText] = React.useState('');
   const [msg, setMsg] = React.useState('');
 
   var columns = [
@@ -80,14 +81,14 @@ export default function Dependents({ nodeData, item, node, ...props }) {
       accessor: 'type',
       sortble: true,
       resizable: false,
-      disableGlobalFilter: true,
+      disableGlobalFilter: false,
     },
     {
       Header: 'Name',
       accessor: 'name',
       sortble: true,
       resizable: false,
-      disableGlobalFilter: true,
+      disableGlobalFilter: false,
     },
     {
       Header: 'Restriction',
@@ -115,6 +116,7 @@ export default function Dependents({ nodeData, item, node, ...props }) {
       );
       if (node.hasDepends && !nodeData.is_collection) {
         const api = getApiInstance();
+        setLoaderText('Loading...');
         api({
           url: url,
           type: 'GET',
@@ -125,6 +127,7 @@ export default function Dependents({ nodeData, item, node, ...props }) {
               setTableData(data);
             } else {
               setMsg(message);
+              setLoaderText('');
             }
           })
           .catch((e) => {
@@ -158,11 +161,15 @@ export default function Dependents({ nodeData, item, node, ...props }) {
         ></PgTable>
       ) : (
         <div className={classes.emptyPanel}>
-          <div className={classes.panelIcon}>
-            <i className="fa fa-exclamation-circle"></i>
-            <span className={classes.panelMessage}>{gettext(msg)}</span>
-          </div>
+          {loaderText ? (<Loader message={loaderText} className={classes.loading} />) :
+
+            <div className={classes.panelIcon}>
+              <i className="fa fa-exclamation-circle"></i>
+              <span className={classes.panelMessage}>{gettext(msg)}</span>
+            </div>
+          }
         </div>
+
       )}
     </>
   );
diff --git a/web/pgadmin/misc/properties/CollectionNodeProperties.jsx b/web/pgadmin/misc/properties/CollectionNodeProperties.jsx
new file mode 100644
index 000000000..a6282f99f
--- /dev/null
+++ b/web/pgadmin/misc/properties/CollectionNodeProperties.jsx
@@ -0,0 +1,290 @@
+/////////////////////////////////////////////////////////////
+//
+// pgAdmin 4 - PostgreSQL Tools
+//
+// Copyright (C) 2013 - 2022, The pgAdmin Development Team
+// This software is released under the PostgreSQL Licence
+//
+//////////////////////////////////////////////////////////////
+import React from 'react';
+import pgAdmin from 'sources/pgadmin';
+import getApiInstance from 'sources/api_instance';
+import { makeStyles } from '@material-ui/core/styles';
+import { Box } from '@material-ui/core';
+import { Switch } from '@material-ui/core';
+import { generateCollectionURL } from '../../browser/static/js/node_ajax';
+import Notify from '../../static/js/helpers/Notifier';
+import gettext from 'sources/gettext';
+import 'wcdocker';
+import PgTable from 'sources/components/PgTable';
+import Theme from 'sources/Theme';
+import PropTypes from 'prop-types';
+import { PgIconButton } from '../../static/js/components/Buttons';
+
+const useStyles = makeStyles((theme) => ({
+  searchPadding: {
+    flex: 2.5
+  },
+  searchInput: {
+    flex: 1,
+    margin: '4 0 4 0',
+    borderLeft: 'none',
+    paddingLeft: 5
+  },
+  propertiesPanel: {
+    height: '100%'
+  },
+  autoResizer: {
+    height: '100% !important',
+    width: '100% !important',
+    background: theme.palette.grey[400],
+    padding: '8px',
+  },
+  dropButton: {
+    marginRight: '5px !important'
+  },
+}));
+
+export function CollectionNodeView({
+  node,
+  treeNodeInfo,
+  itemNodeData,
+  item,
+  pgBrowser
+}) {
+  const classes = useStyles();
+
+  const [data, setData] = React.useState([]);
+  const [selectedObject, setSelectedObject] = React.useState([]);
+  const [reload, setReload] = React.useState();
+
+
+  const [pgTableColumns, setPgTableColumns] = React.useState([
+    {
+      Header: 'properties',
+      accessor: 'Properties',
+      sortble: true,
+      resizable: false,
+      disableGlobalFilter: false,
+    },
+    {
+      Header: 'value',
+      accessor: 'value',
+      sortble: true,
+      resizable: false,
+      disableGlobalFilter: false,
+    },
+  ]);
+
+  const getTableSelectedRows = (selRows) => {
+    setSelectedObject(selRows);
+  };
+
+  const onDrop = (type) => {
+    let selRowModels = selectedObject,
+      selRows = [],
+      selItem = pgBrowser.tree.selected(),
+      selectedItemData = selItem ? pgBrowser.tree.itemData(selItem) : null,
+      selNode = selectedItemData && pgBrowser.Nodes[selectedItemData._type],
+      url = undefined,
+      msg = undefined,
+      title = undefined;
+
+    if (selNode && selNode.type && selNode.type == 'coll-constraints') {
+      // In order to identify the constraint type, the type should be passed to the server
+      selRows = selRowModels.map((row) => ({
+        id: row.get('oid'),
+        _type: row.get('_type'),
+      }));
+    } else {
+      selRows = selRowModels.map((row) => row.original.oid);
+    }
+
+    if (selRows.length === 0) {
+      Notify.alert(
+        gettext('Drop Multiple'),
+        gettext('Please select at least one object to delete.')
+      );
+      return;
+    }
+
+    if (!selNode) return;
+
+    if (type === 'dropCascade') {
+      url = selNode.generate_url(selItem, 'delete');
+      msg = gettext(
+        'Are you sure you want to drop all the selected objects and all the objects that depend on them?'
+      );
+      title = gettext('DROP CASCADE multiple objects?');
+    } else {
+      url = selNode.generate_url(selItem, 'drop');
+      msg = gettext('Are you sure you want to drop all the selected objects?');
+      title = gettext('DROP multiple objects?');
+    }
+
+    const api = getApiInstance();
+    let dropNodeProperties = function () {
+      api
+        .delete(url, {
+          data: JSON.stringify({ ids: selRows }),
+          contentType: 'application/json; charset=utf-8',
+        })
+        .then(function (res) {
+          if (res.success == 0) {
+            pgBrowser.report_error(res.errormsg, res.info);
+          } else {
+            pgBrowser.Events.trigger(
+              'pgadmin:browser:tree:refresh',
+              selItem || pgBrowser.tree.selected(),
+              {
+                success: function () {
+                  pgBrowser.tree.select(selItem);
+                  selNode.callbacks.selected.apply(selNode, [selItem]);
+                },
+              }
+            );
+          }
+          setReload(true);
+        })
+        .catch(function (error) {
+          Notify.error(
+            gettext('Error dropping %s', selectedItemData._label.toLowerCase()),
+            error.message
+          );
+        });
+    };
+
+    if (confirm) {
+      Notify.confirm(title, msg, dropNodeProperties, null);
+    } else {
+      dropNodeProperties();
+    }
+  };
+
+  React.useEffect(() => {
+    let nodeObj =
+      pgAdmin.Browser.Nodes[itemNodeData._type.replace('coll-', '')];
+
+    let schema = nodeObj.getSchema.call(nodeObj, treeNodeInfo, itemNodeData);
+    let url = generateCollectionURL.call(nodeObj, item, 'properties');
+
+    const api = getApiInstance();
+
+    let tableColumns = [];
+    var column = {};
+
+    if (itemNodeData._type.indexOf('coll-') > -1) {
+      schema.fields.forEach((field) => {
+        if (node.columns.indexOf(field.id) > -1) {
+          if (field.label.indexOf('?') > -1) {
+            column = {
+              Header: field.label,
+              accessor: field.id,
+              sortble: true,
+              resizable: false,
+              disableGlobalFilter: false,
+              // eslint-disable-next-line react/display-name
+              Cell: ({ value }) => {
+                return (<Switch checked={Boolean(value)} value={value} disabled title={value}></Switch>);
+              }
+            };
+          } else {
+            column = {
+              Header: field.label,
+              accessor: field.id,
+              sortble: true,
+              resizable: false,
+              disableGlobalFilter: false,
+            };
+          }
+          tableColumns.push(column);
+        }
+      });
+      api({
+        url: url,
+        type: 'GET',
+      })
+        .then((res) => {
+          res.data.forEach((element) => {
+            element['icon'] = '';
+          });
+          setPgTableColumns(tableColumns);
+          setData(res.data);
+        })
+        .catch((err) => {
+          Notify.alert(
+            gettext('Failed to retrieve data from the server.'),
+            gettext(err.message)
+          );
+        });
+    }
+  }, [itemNodeData, node, item, reload]);
+
+  const customHeader = () => {
+    return (
+      <Box >
+        <PgIconButton
+          className={classes.dropButton}
+          variant="outlined"
+          icon={<i className='fa fa-trash-alt delete_multiple' aria-hidden="true" role="img"></i>}
+          aria-label="Delete/Drop"
+          title={gettext('Delete/Drop')}
+          onClick={() => {
+            onDrop('drop');
+          }}
+          disabled={
+            (selectedObject.length > 0)
+              ? !node.canDrop
+              : true
+          }
+        ></PgIconButton>
+        <PgIconButton
+          className={classes.dropButton}
+          variant="outlined"
+          icon={<i className='pg-font-icon icon-drop_cascade delete_multiple_cascade' aria-hidden="true" role="img"></i>}
+          aria-label="Drop Cascade"
+          title={gettext('Drop Cascade')}
+          onClick={() => {
+            onDrop('dropCascade');
+          }}
+          disabled={
+            (selectedObject.length > 0)
+              ? !node.canDropCascade
+              : true
+          }
+        ></PgIconButton>
+      </Box>);
+  };
+
+  return (
+    <Theme>
+      <Box className={classes.propertiesPanel}>
+        <PgTable
+          isSelectRow={true}
+          customHeader={customHeader}
+          className={classes.autoResizer}
+          columns={pgTableColumns}
+          data={data}
+          type={'panel'}
+          isSearch={false}
+          getSelectedRows={getTableSelectedRows}
+        ></PgTable>
+      </Box>
+    </Theme>
+  );
+}
+
+CollectionNodeView.propTypes = {
+  node: PropTypes.func,
+  itemData: PropTypes.object,
+  itemNodeData: PropTypes.object,
+  treeNodeInfo: PropTypes.object,
+  item: PropTypes.object,
+  pgBrowser: PropTypes.object,
+  preferences: PropTypes.object,
+  sid: PropTypes.number,
+  did: PropTypes.number,
+  row: PropTypes.object,
+  serverConnected: PropTypes.bool,
+  value: PropTypes.bool,
+};
diff --git a/web/pgadmin/misc/sql/static/js/SQL.jsx b/web/pgadmin/misc/sql/static/js/SQL.jsx
new file mode 100644
index 000000000..5eec57e8d
--- /dev/null
+++ b/web/pgadmin/misc/sql/static/js/SQL.jsx
@@ -0,0 +1,114 @@
+/////////////////////////////////////////////////////////////
+//
+// pgAdmin 4 - PostgreSQL Tools
+//
+// Copyright (C) 2013 - 2022, The pgAdmin Development Team
+// This software is released under the PostgreSQL Licence
+//
+//////////////////////////////////////////////////////////////
+
+import React, { useEffect } from 'react';
+import { generateNodeUrl } from '../../../../browser/static/js/node_ajax';
+import gettext from 'sources/gettext';
+import PropTypes from 'prop-types';
+import Notify from '../../../../static/js/helpers/Notifier';
+import getApiInstance from 'sources/api_instance';
+import { makeStyles } from '@material-ui/core/styles';
+import CodeMirror from '../../../../static/js/components/CodeMirror';
+
+const useStyles = makeStyles((theme) => ({
+  textArea: {
+    height: '100% !important',
+    width: '100% !important',
+    background: theme.palette.grey[400],
+    overflow: 'auto !important',
+    minHeight: '100%',
+    minWidth: '100%',
+  },
+}));
+
+export default function SQL({ nodeData, node, ...props }) {
+  const classes = useStyles();
+  const [nodeSQL, setNodeSQL] = React.useState('');
+
+  const [msg, setMsg] = React.useState('');
+
+  useEffect(() => {
+    var sql = '-- ' + gettext('Please select an object in the tree view.');
+    if (node) {
+      let url = generateNodeUrl.call(
+        node,
+        props.treeNodeInfo,
+        'sql',
+        nodeData,
+        true,
+        node.url_jump_after_node
+      );
+      sql =
+        '-- ' + gettext('No SQL could be generated for the selected object.');
+
+      if (node.hasSQL) {
+        const api = getApiInstance();
+
+        api({
+          url: url,
+          type: 'GET',
+        })
+          .then((res) => {
+            if (res.data.length > 0) {
+              setNodeSQL(res.data);
+            } else {
+              setMsg(sql);
+            }
+          })
+          .catch((e) => {
+            Notify.alert(
+              gettext('Failed to retrieve data from the server.'),
+              gettext(e.message)
+            );
+            // show failed message.
+            setMsg(gettext('Failed to retrieve data from the server.'));
+          });
+      }
+    }
+    if (sql != '') {
+      setMsg(sql);
+    }
+    return () => {
+      setNodeSQL([]);
+    };
+  }, [nodeData]);
+
+  return (
+    <>
+      {nodeSQL.length > 0 ? (
+        <CodeMirror
+          className={classes.textArea}
+          value={nodeSQL}
+          options={{
+            lineNumbers: true,
+            mode: 'text/x-pgsql',
+            readOnly: true,
+          }}
+        />
+      ) : (
+        <CodeMirror
+          className={classes.textArea}
+          value={msg}
+          options={{
+            lineNumbers: true,
+            mode: 'text/x-pgsql',
+            readOnly: true,
+          }}
+        />
+      )}
+    </>
+  );
+}
+
+SQL.propTypes = {
+  res: PropTypes.array,
+  nodeData: PropTypes.object,
+  treeNodeInfo: PropTypes.object,
+  node: PropTypes.func,
+};
diff --git a/web/pgadmin/misc/statistics/static/js/Statistics.jsx b/web/pgadmin/misc/statistics/static/js/Statistics.jsx
index caf635351..305262680 100644
--- a/web/pgadmin/misc/statistics/static/js/Statistics.jsx
+++ b/web/pgadmin/misc/statistics/static/js/Statistics.jsx
@@ -17,7 +17,7 @@ import getApiInstance from 'sources/api_instance';
 import { makeStyles } from '@material-ui/core/styles';
 import sizePrettify from 'sources/size_prettify';
 import { getURL } from '../../../static/utils/utils';
-
+import Loader from 'sources/components/Loader';
 const useStyles = makeStyles((theme) => ({
   emptyPanel: {
     minHeight: '100%',
@@ -37,12 +37,18 @@ const useStyles = makeStyles((theme) => ({
     marginLeft: '0.5rem',
     fontSize: '0.875rem',
   },
+  loading: {
+    marginLeft: '0.5rem',
+    fontSize: '0.875rem',
+    colour: theme.palette.grey[400]
+  },
   autoResizer: {
     height: '100% !important',
     width: '100% !important',
     background: theme.palette.grey[400],
     padding: '7.5px',
-    overflow: 'auto !important',
+    overflowX: 'auto !important',
+    overflowY: 'hidden !important',
     minHeight: '100%',
     minWidth: '100%',
   },
@@ -58,7 +64,7 @@ function getColumn(data, singleLineStatistics) {
           accessor: row.name,
           sortble: true,
           resizable: false,
-          disableGlobalFilter: true,
+          disableGlobalFilter: false,
         };
         columns.push(column);
       });
@@ -71,14 +77,14 @@ function getColumn(data, singleLineStatistics) {
         accessor: 'name',
         sortble: true,
         resizable: false,
-        disableGlobalFilter: true,
+        disableGlobalFilter: false,
       },
       {
         Header: 'Value',
         accessor: 'value',
         sortble: true,
         resizable: false,
-        disableGlobalFilter: true,
+        disableGlobalFilter: false,
       },
     ];
   }
@@ -142,20 +148,21 @@ export default function Statistics({ nodeData, item, node, ...props }) {
   const [tableData, setTableData] = React.useState([]);
 
   const [msg, setMsg] = React.useState('');
+  const [loaderText, setLoaderText] = React.useState('');
   const [columns, setColumns] = React.useState([
     {
       Header: 'Statictics',
       accessor: 'name',
       sortble: true,
       resizable: false,
-      disableGlobalFilter: true,
+      disableGlobalFilter: false,
     },
     {
       Header: 'Value',
       accessor: 'value',
       sortble: true,
       resizable: false,
-      disableGlobalFilter: true,
+      disableGlobalFilter: false,
     },
   ]);
 
@@ -170,6 +177,7 @@ export default function Statistics({ nodeData, item, node, ...props }) {
 
       const api = getApiInstance();
       if (node.hasStatistics) {
+        setLoaderText('Loading...');
         api({
           url: url,
           type: 'GET',
@@ -180,6 +188,7 @@ export default function Statistics({ nodeData, item, node, ...props }) {
             if (!_.isUndefined(colData)) {
               setColumns(colData);
             }
+            setLoaderText('');
           })
           .catch((e) => {
             Notify.alert(
@@ -187,10 +196,12 @@ export default function Statistics({ nodeData, item, node, ...props }) {
               gettext(e.message)
             );
             // show failed message.
+            setLoaderText('');
             setMsg(gettext('Failed to retrieve data from the server.'));
           });
       } else {
-        setMsg(message);
+        setLoaderText('');
+        setMsg('No statistics are available for the selected object.');
       }
     }
     if (message != '') {
@@ -213,10 +224,12 @@ export default function Statistics({ nodeData, item, node, ...props }) {
         ></PgTable>
       ) : (
         <div className={classes.emptyPanel}>
-          <div className={classes.panelIcon}>
-            <i className="fa fa-exclamation-circle"></i>
-            <span className={classes.panelMessage}>{gettext(msg)}</span>
-          </div>
+          {loaderText ? (<Loader message={loaderText} className={classes.loading} />) :
+            <div className={classes.panelIcon}>
+              <i className="fa fa-exclamation-circle"></i>
+              <span className={classes.panelMessage}>{gettext(msg)}</span>
+            </div>
+          }
         </div>
       )}
     </>
diff --git a/web/pgadmin/static/js/Theme/standard.js b/web/pgadmin/static/js/Theme/standard.js
index ddc9cd735..8cf463a71 100644
--- a/web/pgadmin/static/js/Theme/standard.js
+++ b/web/pgadmin/static/js/Theme/standard.js
@@ -85,6 +85,7 @@ export default function(basicSettings) {
         padding: '5px 8px',
       },
       borderColor: '#dde0e6',
+      colorFg: '#222222',
       loader: {
         backgroundColor: fade('#000', 0.65),
         color: '#fff',
@@ -102,6 +103,7 @@ export default function(basicSettings) {
       toggleBtnBg: '#000',
       editorToolbarBg: '#ebeef3',
       datagridBg: '#fff',
+
     }
   });
 }
